-- name: [CS] Ario
-- description: Ario, the Star bun, playable!\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

E_MODEL_ARIO = smlua_model_util_get_id('ario_geo')
E_MODEL_ARIO_CLOUD = smlua_model_util_get_id('ario_cloud_geo')

local TEX_ARIO_ICON = get_texture_info('ario-icon')

local TEXT_MOD_NAME = "[CS] Ario"

local VOICETABLE_ARIO = {
    [CHAR_SOUND_ATTACKED] = 'ouch.ogg',
    [CHAR_SOUND_COUGHING1] = 'gah1.ogg',
    [CHAR_SOUND_COUGHING2] = 'gah1.ogg',
    [CHAR_SOUND_COUGHING3] = 'guh.ogg',
    [CHAR_SOUND_DOH] = 'nyo.ogg',
    [CHAR_SOUND_DROWNING] = 'drowning.ogg',
    [CHAR_SOUND_DYING] = 'dying.ogg',
    [CHAR_SOUND_EEUH] = 'eeyup.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'woah.ogg',
    [CHAR_SOUND_HAHA] = 'hehehe.ogg',
    [CHAR_SOUND_HAHA_2] = 'hehehe.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'yipee_big.ogg',
    [CHAR_SOUND_HOOHOO] = 'wehe.ogg',
    [CHAR_SOUND_HRMM] = 'eeyup.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'eepy.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'angy.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'letsgo.ogg',
    [CHAR_SOUND_ON_FIRE] = 'hothot.ogg',
    [CHAR_SOUND_OOOF] = 'gah0.ogg',
    [CHAR_SOUND_OOOF2] = 'gah1.ogg',
    [CHAR_SOUND_PANTING] = 'pant.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'pant.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'hit2.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'hit1.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'hit0.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'letsgo.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'yipee2.ogg',
    [CHAR_SOUND_UH] = 'guh.ogg',
    [CHAR_SOUND_UH2] = 'guh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'falling.ogg',
    [CHAR_SOUND_WAH2] = 'hit1.ogg',
    [CHAR_SOUND_WHOA] = 'woah.ogg',
    [CHAR_SOUND_YAHOO] = 'whee.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'yipee0.ogg', 'yipee1.ogg', 'yipee2.ogg' },
    [CHAR_SOUND_YAH_WAH_HOO] = { 'jump0.ogg', 'jump1.ogg', 'jump2.ogg' },
}

CAPMODELS_ARIO = {
    normal = smlua_model_util_get_id('ario_cap_geo'),
    metal = smlua_model_util_get_id('ario_metal_cap_geo'),
    wing = smlua_model_util_get_id('ario_wing_cap_geo'),
    metalWing = smlua_model_util_get_id('ario_metal_wing_cap_geo'),
}

CAPMODELS_ARIO_CLOUD = {
    normal = smlua_model_util_get_id('ario_cloud_cap_geo'),
    metal = smlua_model_util_get_id('ario_cloud_metal_cap_geo'),
    wing = smlua_model_util_get_id('ario_cloud_wing_cap_geo'),
    metalWing = smlua_model_util_get_id('ario_cloud_metal_wing_cap_geo'),
}

local PALETTE_ARIO = {
    [SHIRT] = "D61D39",
    [SHOES] = "ffffff",
    [HAIR] = "ffffff",
    [CAP] = "D61D39",
    [PANTS] = "475EFF",
    [GLOVES] = "FFFFFF",
    [SKIN] = "FFC411",
    [EMBLEM] = "D61D39",
}

local PALETTE_ARIO_CLOUD = {
    [SHIRT] = "E66E76",
    [SHOES] = "ffffff",
    [HAIR] = "ffffff",
    [CAP] = "FFA7AD",
    [PANTS] = "475EFF",
    [GLOVES] = "FFFFFF",
    [SKIN] = "FFC411",
    [EMBLEM] = "D61D39",
}

if not _G.charSelectExists then
    djui_popup_create(
        "\\#ffffdc\\\n" ..
        TEXT_MOD_NAME ..
        "\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!",
        6)
    return
end

CT_ARIO = _G.charSelect.character_add("Ario", { "The Fluffy Star Bun!", "", "(Character credits to AceTheBun!)" },
    "wibblus", { r = 255, g = 180, b = 200 },
    E_MODEL_ARIO_CLOUD, CT_MARIO, TEX_ARIO_ICON)
_G.charSelect.character_add_costume(CT_ARIO, "Ario", { "The Star Bun!", "", "(Character credits to AceTheBun!)" }, nil,
    { r = 255, g = 100, b = 130 },
    E_MODEL_ARIO, nil, nil, nil)

_G.charSelect.character_add_palette_preset(E_MODEL_ARIO, PALETTE_ARIO)
_G.charSelect.character_add_palette_preset(CAPMODELS_ARIO.normal, PALETTE_ARIO)
_G.charSelect.character_add_palette_preset(E_MODEL_ARIO_CLOUD, PALETTE_ARIO_CLOUD)
_G.charSelect.character_add_palette_preset(CAPMODELS_ARIO_CLOUD.normal, PALETTE_ARIO_CLOUD)

_G.charSelect.character_add_caps(E_MODEL_ARIO, CAPMODELS_ARIO)
_G.charSelect.character_add_caps(E_MODEL_ARIO_CLOUD, CAPMODELS_ARIO_CLOUD)

_G.charSelect.character_add_voice(E_MODEL_ARIO, VOICETABLE_ARIO)
_G.charSelect.character_add_voice(CAPMODELS_ARIO.normal, VOICETABLE_ARIO)
_G.charSelect.character_add_voice(E_MODEL_ARIO_CLOUD, VOICETABLE_ARIO)
_G.charSelect.character_add_voice(CAPMODELS_ARIO_CLOUD.normal, VOICETABLE_ARIO)

_G.charSelect.config_character_sounds()

---- UTILS

local function is_ground_act_actionable(action)
    return action & ACT_FLAG_ALLOW_FIRST_PERSON ~= 0
end
local function is_air_act_actionable(action)
    local actId = action & ACT_ID_MASK
    return (actId >= 0x080 and actId <= 0x099 and action & (ACT_FLAG_DIVING | ACT_FLAG_ATTACKING) == 0) or
        action == ACT_SPECIAL_TRIPLE_JUMP
end
local function is_water_act_actionable(action)
    return action == ACT_WATER_IDLE or action == ACT_SWIMMING_END or action == ACT_WATER_ACTION_END
end
local function is_kb_act(action)
    return action & (ACT_FLAG_INVULNERABLE | ACT_FLAG_INTANGIBLE) == ACT_FLAG_INVULNERABLE
end

local capGuardModels = {
    { base = E_MODEL_ARIO_CLOUD, cap = CAPMODELS_ARIO_CLOUD.normal },
    { base = E_MODEL_ARIO,       cap = CAPMODELS_ARIO.normal }
}

function ario_enter_cap_model(m)
    if m.playerIndex ~= 0 then return end
    local alt = _G.charSelect.character_get_current_costume(0)

    --_G.charSelect.character_edit_costume(CT_ARIO, alt, nil, nil, nil, nil, capGuardModels[alt].cap)
    _G.charSelect.restrict_palettes(true)
    _G.charSelect.character_get_current_table(CT_ARIO, alt).model = capGuardModels[alt].cap

    set_mario_particle_flags(m, PARTICLE_MIST_CIRCLE, 0)
end

function ario_exit_cap_model(m)
    if m.playerIndex ~= 0 then return end
    local alt = _G.charSelect.character_get_current_costume(0)

    --_G.charSelect.character_edit_costume(CT_ARIO, alt, nil, nil, nil, nil, capGuardModels[alt].base)
    _G.charSelect.restrict_palettes(false)
    _G.charSelect.character_get_current_table(CT_ARIO, alt).model = capGuardModels[alt].base

    set_mario_particle_flags(m, PARTICLE_MIST_CIRCLE, 0)
end

---- VARS

gStateExtras = {}
for i = 0, MAX_PLAYERS - 1 do
    gStateExtras[i] = {}
    local e = gStateExtras[i]
    -- timer for individual flaps
    e.earFlapTimer = 0
    -- num of flaps used in a single jump
    e.earFlapsUsed = 0
    e.capHideHits = 0
    e.restrictCapThrow = false
    e.airSpinUsed = false
end

---- HOOKED FUNCTIONS

---@param m MarioState
local function before_mario_update(m)
    if m.playerIndex ~= 0 or is_game_paused() then return end
    local e = gStateExtras[m.playerIndex]

    local button = m.controller.buttonPressed
    if button & Y_BUTTON ~= 0 then
        if is_ground_act_actionable(m.action) then
            set_mario_action(m, ACT_ARIO_SPIN, 0)
        elseif is_air_act_actionable(m.action) and not e.airSpinUsed then
            set_mario_action(m, ACT_ARIO_AIR_SPIN, 0)
            e.airSpinUsed = true
        elseif is_water_act_actionable(m.action) then
            set_mario_action(m, ACT_ARIO_WATER_SPIN, 0)
        end
    elseif button & X_BUTTON ~= 0 and not gPlayerSyncTable[0].capThrown and not e.restrictCapThrow and m.flags & MARIO_NORMAL_CAP ~= 0 then
        if (m.action == ACT_CROUCHING or m.action == ACT_ARIO_ROLL) and m.forwardVel < 8.0 then
            play_sound(SOUND_OBJ2_MONTY_MOLE_APPEAR, m.marioObj.header.gfx.cameraToObject)
            set_mario_action(m, ACT_ARIO_CAP_HIDE, 0)
        elseif is_water_act_actionable(m.action) then
            play_sound(SOUND_OBJ2_MONTY_MOLE_APPEAR, m.marioObj.header.gfx.cameraToObject)
            set_mario_action(m, ACT_ARIO_CAP_HIDE_WATER, 0)
        elseif is_ground_act_actionable(m.action) then
            set_mario_action(m, ACT_ARIO_CAP_THROW, 0)
        elseif is_air_act_actionable(m.action) then
            set_mario_action(m, ACT_ARIO_CAP_THROW, 1)
            m.vel.y = math.max(5.0, m.vel.y)
        end
    end
end
_G.charSelect.character_hook_moveset(CT_ARIO, HOOK_BEFORE_MARIO_UPDATE, before_mario_update)

---@param m MarioState
local function mario_update(m)
    local e = gStateExtras[m.playerIndex]
    if gPlayerSyncTable[m.playerIndex].earFlap then
        m.marioBodyState.eyeState = 7
        m.marioBodyState.wingFlutter = 1
    end
    if gPlayerSyncTable[m.playerIndex].capThrown then
        m.marioBodyState.capState = 1
    end

    if (m.action == ACT_ARIO_AIR_ROLL and m.actionState == 1) then
        obj_scale_xyz(m.marioObj, 1.0, 1.5, 1.0)
    elseif m.action == ACT_ARIO_CAP_HIDE or m.action == ACT_ARIO_CAP_HIDE_WATER then
        obj_scale_xyz(m.marioObj, 1.25, 1.5, 1.25)
    end

    if m.playerIndex ~= 0 then return end

    if m.controller.buttonPressed & A_BUTTON ~= 0 then
        if m.action & ACT_GROUP_MASK == ACT_GROUP_AIRBORNE and m.action & (ACT_FLAG_DIVING | ACT_FLAG_INVULNERABLE) == 0 and m.vel.y < 4 then
            e.earFlapTimer = 5
            e.earFlapsUsed = e.earFlapsUsed + 1
            gPlayerSyncTable[0].earFlap = true

            m.forwardVel = math.min(m.forwardVel, 25)
            m.peakHeight = m.pos.y
            play_sound(SOUND_GENERAL_SWISH_AIR, m.marioObj.header.gfx.cameraToObject)
        end
    end
    -- ear flap loop
    if e.earFlapTimer > 0 then
        -- start losing height after 10 flaps
        m.vel.y = math.max(-1 - math.max(0, e.earFlapsUsed - 10), m.vel.y)

        e.earFlapTimer = e.earFlapTimer - 1
        if e.earFlapTimer <= 0 then
            gPlayerSyncTable[0].earFlap = false
        end
    end

    if m.action == ACT_SQUISHED then
        m.hurtCounter = 0
    end
    if m.action == ACT_SLEEPING then
        m.healCounter = 0x2
    elseif m.action == ACT_BACKFLIP then
        if m.vel.y <= 10 then set_mario_action(m, ACT_TWIRLING, 0) end
    elseif m.action == ACT_CROUCH_SLIDE and m.actionTimer >= 8 then
        set_mario_action(m, ACT_ARIO_ROLL, 0)
    end

    if abs_angle_diff(m.faceAngle.y, m.intendedYaw) < 0x5000 then
        if m.action == ACT_WALKING then
            m.faceAngle.y = approach_s16_symmetric(m.faceAngle.y, m.intendedYaw, 0x0200)
        elseif m.action & ACT_GROUP_MASK == ACT_GROUP_AIRBORNE and m.action & (ACT_FLAG_DIVING | ACT_FLAG_ATTACKING | ACT_FLAG_INVULNERABLE) == 0 then
            m.faceAngle.y = approach_s16_symmetric(m.faceAngle.y, m.intendedYaw,
                (1 - math.min(m.forwardVel / 60.0, 1.0)) * 0x0400)
        end
    end
end
_G.charSelect.character_hook_moveset(CT_ARIO, HOOK_MARIO_UPDATE, mario_update)

---@param m MarioState
local function before_set_action(m, incomingAct)
    if m.playerIndex ~= 0 then return end
    local e = gStateExtras[m.playerIndex]

    if m.action == ACT_ARIO_CAP_HIDE or m.action == ACT_ARIO_CAP_HIDE_WATER then
        if is_kb_act(incomingAct) then
            m.invincTimer = 30
            e.capHideHits = e.capHideHits + 1
            if e.capHideHits < 3 then
                play_sound(SOUND_ACTION_BONK, m.marioObj.header.gfx.cameraToObject)
                return 1
            end
        end
        ario_exit_cap_model(m)
        if e.capHideHits >= 3 then
            return m.action == ACT_ARIO_CAP_HIDE_WATER and ACT_BACKWARD_WATER_KB or ACT_HARD_BACKWARD_GROUND_KB
        end
    end
    if incomingAct == ACT_TRIPLE_JUMP then
        m.vel.y = 69
        return ACT_SPECIAL_TRIPLE_JUMP
    end
    if incomingAct == ACT_DIVE and m.action == ACT_SPECIAL_TRIPLE_JUMP and m.actionState == 0 then
        m.forwardVel = 56.0
        m.vel.y = 8.0
        m.input = m.input & ~INPUT_B_PRESSED
        play_sound(SOUND_ACTION_SIDE_FLIP_UNK, m.marioObj.header.gfx.cameraToObject)
        return ACT_FREEFALL
    end
    if incomingAct == ACT_WALKING and m.controller.buttonDown & Z_TRIG ~= 0 then
        if m.action == ACT_PUNCHING then
            return ACT_START_CRAWLING
        else
            return ACT_CROUCH_SLIDE
        end
    end
    if incomingAct == ACT_GROUND_POUND then
        return ACT_ARIO_AIR_ROLL
    end
    if (incomingAct == ACT_CROUCHING and not (m.action == ACT_PUNCHING or m.action == ACT_STOP_CRAWLING))
        or (incomingAct == ACT_ARIO_SPIN and m.action == ACT_CROUCH_SLIDE) then
        return ACT_ARIO_ROLL
    end
end
_G.charSelect.character_hook_moveset(CT_ARIO, HOOK_BEFORE_SET_MARIO_ACTION, before_set_action)

---@param m MarioState
local function on_set_action(m)
    if m.playerIndex ~= 0 then return end
    local e = gStateExtras[m.playerIndex]

    -- on grounded
    if m.action & ACT_FLAG_AIR == 0 then
        e.earFlapsUsed = 0
        e.airSpinUsed = false
        e.restrictCapThrow = false
    end
    if is_kb_act(m.action) then
        m.forwardVel = m.forwardVel * 1.75
    end
    if m.wallKickTimer > 0 and m.input & INPUT_A_DOWN ~= 0 then
        mario_bonk_reflection(m, 0)
        m.forwardVel = 0
        return set_mario_action(m, ACT_WALL_KICK_AIR, 0)
    end
end
_G.charSelect.character_hook_moveset(CT_ARIO, HOOK_ON_SET_MARIO_ACTION, on_set_action)

local function on_warp()
    if gPlayerSyncTable[0].capThrown then gPlayerSyncTable[0].capThrown = false end
end
hook_event(HOOK_ON_WARP, on_warp)

---- INTERACTIONS

local projectileBhvList = {}
do
    local bhvList = {
        id_bhvSnufitBalls, id_bhvFlamethrowerFlame, id_bhvFlyguyFlame, id_bhvFlameBouncing, id_bhvBulletBill,
        id_bhvHauntedChair,
        id_bhvSmallPiranhaFlame, id_bhvBetaMovingFlames, id_bhvSnowBall, id_bhvBouncingFireball, id_bhvSnowBall,
        id_bhvMrIParticle,
        id_bhvBouncingFireballFlame, id_bhvFlameBowser, id_bhvFlameMovingForwardGrowing, id_bhvVolcanoFlames,
        id_bhvBobomb,
        id_bhvBreakableBoxSmall, id_bhvMrBlizzardSnowball, id_bhvArenaFlame, id_bhvArenaCannonBall
    }
    for index, value in ipairs(bhvList) do
        projectileBhvList[value] = true
    end
end

---@param m MarioState
---@param o Object
---@param type integer
local function allow_interact(m, o, type)
    if _G.charSelect.character_get_current_number(m.playerIndex) ~= CT_ARIO then return end
    if (m.action == ACT_ARIO_SPIN or m.action == ACT_ARIO_AIR_SPIN) and projectileBhvList[get_id_from_behavior(o.behavior)] then
        o.oMoveAngleYaw = approach_s16_asymptotic(o.oMoveAngleYaw - 0x8000, m.faceAngle.y, 2)
        o.oForwardVel = maxf(20.0, o.oForwardVel * 1.5)
        o.oIntangibleTimer = -1
        play_sound(SOUND_OBJ_SNUFIT_SHOOT, o.header.gfx.cameraToObject)
        return false
    end
    if type == INTERACT_BOUNCE_TOP or type == INTERACT_BOUNCE_TOP2 then
        if determine_interaction(m, o) == INT_HIT_FROM_ABOVE and m.action ~= ACT_ARIO_AIR_ROLL then
            m.vel.y = 50.0
            play_sound(SOUND_ACTION_BONK, m.marioObj.header.gfx.cameraToObject)
            if o.oInteractionSubtype & INT_SUBTYPE_TWIRL_BOUNCE ~= 0 then
                set_mario_action(m, ACT_TWIRLING, 0)
                m.vel.y = 75.0
                play_character_sound(m, CHAR_SOUND_TWIRL_BOUNCE)
            end
            return false
        end
    end
end
--_G.charSelect.character_hook_moveset(CT_ARIO, HOOK_ALLOW_INTERACT, allow_interact)
hook_event(HOOK_ALLOW_INTERACT, allow_interact)

local TEX_METER3 = {
    [0] = get_texture_info('meter3_0'),
    get_texture_info('meter3_1'),
    get_texture_info('meter3_2'),
    get_texture_info('meter3_3')
}

local function on_hud_render_behind()
    local m = gMarioStates[0]
    if m.action == ACT_ARIO_CAP_HIDE or m.action == ACT_ARIO_CAP_HIDE_WATER then
        djui_hud_set_resolution(RESOLUTION_N64)
        local pos = { x = 0, y = 0, z = 0 }
        if djui_hud_world_pos_to_screen_pos(m.pos, pos) then
            djui_hud_render_texture(TEX_METER3[3 - gStateExtras[0].capHideHits], pos.x + 16, pos.y - 32, 1, 1)
        end
    end
end
_G.charSelect.character_hook_moveset(CT_ARIO, HOOK_ON_HUD_RENDER_BEHIND, on_hud_render_behind)
